import React, { PureComponent } from 'react';

import SceneView from '../SceneView';
import withCachedChildNavigation from '../../withCachedChildNavigation';

/**
 * Component that renders child screen of the drawer.
 */
class DrawerScreen extends PureComponent {

  render() {
    const { router, navigation, childNavigationProps } = this.props;
    const { routes, index } = navigation.state;
    const childNavigation = childNavigationProps[routes[index].key];
    const Content = router.getComponentForRouteName(routes[index].routeName);
    return <SceneView screenProps={this.props.screenProps} component={Content} navigation={childNavigation} />;
  }
}

export default withCachedChildNavigation(DrawerScreen);