import React, { PureComponent } from 'react';

let screenPropsWarningShown = false;

export default class SceneView extends PureComponent {
  static childContextTypes = {
    navigation: React.PropTypes.object.isRequired
  };

  getChildContext() {
    return {
      navigation: this.props.navigation
    };
  }

  componentWillMount() {
    if (this.props.screenProps !== undefined && !screenPropsWarningShown) {
      console.warn('Behaviour of screenProps has changed from initial beta. ' + 'Components will now receive it as `this.props.screenProps` instead.\n' + 'This warning will be removed in future.');
      screenPropsWarningShown = true;
    }
  }

  render() {
    const {
      screenProps,
      navigation,
      component: Component
    } = this.props;

    return <Component screenProps={screenProps} navigation={navigation} />;
  }
}