'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactNative = require('react-native');

var _ReactComponentWithPureRenderMixin = require('react/lib/ReactComponentWithPureRenderMixin');

var _ReactComponentWithPureRenderMixin2 = _interopRequireDefault(_ReactComponentWithPureRenderMixin);

var _HeaderTitle = require('./HeaderTitle');

var _HeaderTitle2 = _interopRequireDefault(_HeaderTitle);

var _HeaderBackButton = require('./HeaderBackButton');

var _HeaderBackButton2 = _interopRequireDefault(_HeaderBackButton);

var _HeaderStyleInterpolator = require('./HeaderStyleInterpolator');

var _HeaderStyleInterpolator2 = _interopRequireDefault(_HeaderStyleInterpolator);

var _PropTypes = require('../PropTypes');

var _PropTypes2 = _interopRequireDefault(_PropTypes);

var _addNavigationHelpers = require('../addNavigationHelpers');

var _addNavigationHelpers2 = _interopRequireDefault(_addNavigationHelpers);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var APPBAR_HEIGHT = _reactNative.Platform.OS === 'ios' ? 44 : 56;
var STATUSBAR_HEIGHT = _reactNative.Platform.OS === 'ios' ? 20 : 0;

var Header = function (_React$Component) {
  _inherits(Header, _React$Component);

  function Header() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Header);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Header.__proto__ || Object.getPrototypeOf(Header)).call.apply(_ref, [this].concat(args))), _this), _this._renderTitleComponent = function (props) {
      var titleStyle = _this._getHeaderTitleStyle(props.navigation);
      var color = _this._getHeaderTintColor(props.navigation);
      var title = _this._getHeaderTitle(props.navigation);
      return _react2.default.createElement(
        _HeaderTitle2.default,
        { style: [color && { color: color }, titleStyle] },
        title
      );
    }, _this._renderLeftComponent = function (props) {
      if (props.scene.index === 0 || !props.onNavigateBack) {
        return null;
      }
      var tintColor = _this._getHeaderTintColor(props.navigation);
      // @todo(grabobu):
      // We have implemented support for back button label (which works 100% fine),
      // but when title is too long, it will overlap the <HeaderTitle />.
      // We had to revert the PR implementing that because of Android issues,
      // I will land it this week and re-enable that for next release.
      //
      // const previousNavigation = addNavigationHelpers({
      //   ...props.navigation,
      //   state: props.scenes[props.scene.index - 1].route,
      // });
      // const backButtonTitle = this._getHeaderTitle(previousNavigation);
      return _react2.default.createElement(_HeaderBackButton2.default, {
        onPress: props.onNavigateBack,
        tintColor: tintColor
      });
    }, _this._renderRightComponent = function () {
      return null;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  // propTypes for people who don't use Flow


  _createClass(Header, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return _ReactComponentWithPureRenderMixin2.default.shouldComponentUpdate.call(this, nextProps, nextState);
    }
  }, {
    key: '_getHeaderTitle',
    value: function _getHeaderTitle(navigation) {
      var header = this.props.router.getScreenConfig(navigation, 'header');
      var title = void 0;
      if (header && header.title) {
        title = header.title;
      } else {
        title = this.props.router.getScreenConfig(navigation, 'title');
      }
      return typeof title === 'string' ? title : undefined;
    }
  }, {
    key: '_getHeaderTintColor',
    value: function _getHeaderTintColor(navigation) {
      var header = this.props.router.getScreenConfig(navigation, 'header');
      if (header && header.tintColor) {
        return header.tintColor;
      }
      return undefined;
    }
  }, {
    key: '_getHeaderTitleStyle',
    value: function _getHeaderTitleStyle(navigation) {
      var header = this.props.router.getScreenConfig(navigation, 'header');
      if (header && header.titleStyle) {
        return header.titleStyle;
      }
      return undefined;
    }
  }, {
    key: '_renderLeft',
    value: function _renderLeft(props) {
      return this._renderSubView(props, 'left', this.props.renderLeftComponent, this._renderLeftComponent, _HeaderStyleInterpolator2.default.forLeft);
    }
  }, {
    key: '_renderTitle',
    value: function _renderTitle(props, options) {
      var style = {};

      if (_reactNative.Platform.OS === 'android') {
        if (!options.hasLeftComponent) {
          style.left = 0;
        }
        if (!options.hasRightComponent) {
          style.right = 0;
        }
      }

      return this._renderSubView(_extends({}, props, { style: style }), 'title', this.props.renderTitleComponent, this._renderTitleComponent, _HeaderStyleInterpolator2.default.forCenter);
    }
  }, {
    key: '_renderRight',
    value: function _renderRight(props) {
      return this._renderSubView(props, 'right', this.props.renderRightComponent, this._renderRightComponent, _HeaderStyleInterpolator2.default.forRight);
    }
  }, {
    key: '_renderSubView',
    value: function _renderSubView(props, name, renderer, defaultRenderer, styleInterpolator) {
      var scene = props.scene,
          navigationState = props.navigationState;
      var index = scene.index,
          isStale = scene.isStale,
          key = scene.key;


      var offset = navigationState.index - index;

      if (Math.abs(offset) > 2) {
        // Scene is far away from the active scene. Hides it to avoid unnecessary
        // rendering.
        return null;
      }

      var subViewProps = _extends({}, props, {
        onNavigateBack: this.props.onNavigateBack
      });

      var subView = renderer(subViewProps);
      if (subView === undefined) {
        subView = defaultRenderer(subViewProps);
      }

      if (subView === null) {
        return null;
      }

      var pointerEvents = offset !== 0 || isStale ? 'none' : 'box-none';
      return _react2.default.createElement(
        _reactNative.Animated.View,
        {
          pointerEvents: pointerEvents,
          key: name + '_' + key,
          style: [styles.item, styles[name], props.style, styleInterpolator(props)]
        },
        subView
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      // eslint-disable-next-line no-unused-vars
      var _props = this.props,
          scenes = _props.scenes,
          scene = _props.scene,
          style = _props.style,
          position = _props.position,
          progress = _props.progress,
          rest = _objectWithoutProperties(_props, ['scenes', 'scene', 'style', 'position', 'progress']);

      var leftComponents = null;
      var titleComponents = null;
      var rightComponents = null;

      if (this.props.mode === 'float') {
        var scenesProps = scenes.map(function (scene, index) {
          var props = _PropTypes2.default.extractSceneRendererProps(_this2.props);
          props.scene = scene;
          props.index = index;
          props.navigation = (0, _addNavigationHelpers2.default)(_extends({}, _this2.props.navigation, {
            state: scene.route
          }));
          return props;
        });
        leftComponents = scenesProps.map(this._renderLeft, this);
        rightComponents = scenesProps.map(this._renderRight, this);
        titleComponents = scenesProps.map(function (props, i) {
          return _this2._renderTitle(props, {
            hasLeftComponent: leftComponents && !!leftComponents[i],
            hasRightComponent: rightComponents && !!rightComponents[i]
          });
        });
      } else {
        var staticRendererProps = _extends({}, this.props, {
          position: new _reactNative.Animated.Value(scene.index),
          progress: new _reactNative.Animated.Value(0)
        });
        leftComponents = this._renderLeft(staticRendererProps);
        rightComponents = this._renderRight(staticRendererProps);
        titleComponents = this._renderTitle(staticRendererProps, {
          hasLeftComponent: !!leftComponents,
          hasRightComponent: !!rightComponents
        });
      }

      return _react2.default.createElement(
        _reactNative.Animated.View,
        _extends({}, rest, { style: [styles.container, style] }),
        _react2.default.createElement(
          _reactNative.View,
          { style: styles.appBar },
          titleComponents,
          leftComponents,
          rightComponents
        )
      );
    }
  }]);

  return Header;
}(_react2.default.Component);

Header.HEIGHT = APPBAR_HEIGHT + STATUSBAR_HEIGHT;
Header.Title = _HeaderTitle2.default;
Header.BackButton = _HeaderBackButton2.default;
Header.propTypes = _extends({}, _PropTypes2.default.SceneRendererProps, {
  onNavigateBack: _react.PropTypes.func,
  renderLeftComponent: _react.PropTypes.func,
  renderRightComponent: _react.PropTypes.func,
  renderTitleComponent: _react.PropTypes.func,
  router: _react.PropTypes.object,
  style: _react.PropTypes.any
});


var styles = _reactNative.StyleSheet.create({
  container: {
    paddingTop: STATUSBAR_HEIGHT,
    backgroundColor: _reactNative.Platform.OS === 'ios' ? '#EFEFF2' : '#FFF',
    shadowColor: 'black',
    shadowOpacity: 0.1,
    shadowRadius: _reactNative.StyleSheet.hairlineWidth,
    shadowOffset: {
      height: _reactNative.StyleSheet.hairlineWidth
    },
    elevation: 4
  },
  appBar: {
    height: APPBAR_HEIGHT
  },
  item: {
    flexDirection: 'row',
    alignItems: 'center'
  },
  title: {
    bottom: 0,
    left: 40,
    position: 'absolute',
    right: 40,
    top: 0
  },
  left: {
    bottom: 0,
    left: 0,
    position: 'absolute',
    top: 0
  },
  right: {
    bottom: 0,
    position: 'absolute',
    right: 0,
    top: 0
  }
});

module.exports = Header;