'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactNative = require('react-native');

var _TouchableItem = require('./TouchableItem');

var _TouchableItem2 = _interopRequireDefault(_TouchableItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var HeaderBackButton = function HeaderBackButton(_ref) {
  var onPress = _ref.onPress,
      title = _ref.title,
      tintColor = _ref.tintColor;
  return _react2.default.createElement(
    _TouchableItem2.default,
    {
      delayPressIn: 0,
      onPress: onPress,
      style: styles.container,
      borderless: true
    },
    _react2.default.createElement(
      _reactNative.View,
      { style: styles.container },
      _react2.default.createElement(_reactNative.Image, {
        style: [styles.icon, title && styles.iconWithTitle, { tintColor: tintColor }],
        source: require('./assets/back-icon.png')
      }),
      _reactNative.Platform.OS === 'ios' && title && _react2.default.createElement(
        _reactNative.Text,
        { style: [styles.title, { color: tintColor }] },
        title
      )
    )
  );
};

HeaderBackButton.propTypes = {
  onPress: _react.PropTypes.func.isRequired,
  tintColor: _react.PropTypes.string
};

HeaderBackButton.defaultProps = {
  tintColor: _reactNative.Platform.select({
    ios: '#037aff'
  })
};

var styles = _reactNative.StyleSheet.create({
  container: {
    alignItems: 'center',
    justifyContent: 'center',
    flexDirection: 'row'
  },
  title: {
    fontSize: 17,
    paddingRight: 10
  },
  icon: _reactNative.Platform.OS === 'ios' ? {
    height: 20,
    width: 12,
    marginLeft: 10,
    marginRight: 22,
    marginVertical: 12,
    resizeMode: 'contain',
    transform: [{ scaleX: _reactNative.I18nManager.isRTL ? -1 : 1 }]
  } : {
    height: 24,
    width: 24,
    margin: 16,
    resizeMode: 'contain',
    transform: [{ scaleX: _reactNative.I18nManager.isRTL ? -1 : 1 }]
  },
  iconWithTitle: _reactNative.Platform.OS === 'ios' ? {
    marginRight: 5
  } : {}
});

exports.default = HeaderBackButton;